"""Main module."""
from sphoin.utils import get_terminal_size, api_upload, generate_config

import requests
import json
import time
import sys,select
import os
import datetime as dt

class Slot():

	def __init__(self,**kwargs):
		self.base_url = "https://api.sphoin.app/apiv1"
		if "file" in kwargs:
			self.load_file(file=kwargs["file"])
		elif "token" not in kwargs:
			raise ValueError("token")
		elif "secret" not in kwargs:
			raise ValueError("secret")
		self.token = kwargs["token"]
		self.secret = kwargs["secret"]
		self.api_json()
		return

	def load_file(self,file):
		while True:
			if file != "example":
				with open(file,"r") as f:
					data = json.load(f)
			else:
				data = {"token" : "111Y0URT0K3N1111","secret" : "111Y0URS3CR3T111","loop" : ["line","studies","sum"]}
			self.token = data["token"]
			self.secret = data["secret"]
			if "sphoin.slot" in list(data):
				self.config = {"sphoin.slot": data["sphoin.slot"]}
				self.upload()
				time.sleep(1)
			else:
				if file != "example" and input("Configure .json file? Yes/No: ") in ["y","Y","yes","Yes",""]:
					fi = generate_config(overwrite=file)
					if fi != 0:
						with open(fi,"r") as f:
							data = json.load(f)
						self.token = data["token"]
						self.secret = data["secret"]
						self.config = {"sphoin.slot": data["sphoin.slot"]}
						self.upload()
						time.sleep(1)
				elif file != "example":
					sys.exit()

			
			j = self.api_json()
			if "slot_error" not in list(j):
				if not isinstance(data["loop"],list):
					raise ValueError("loop not list")
				self.loop = data["loop"]
				self.evaluate(banner=True)
			else:
				print("Error\nMight want to check 'sphoin --generate'")
				sys.exit()

			if file != "example":
				with open(file,"w") as f:
					data["sphoin.slot"]["flag"] = str(self.flag)
					json.dump(data, f,indent=5, sort_keys=False)
					time.sleep(1)



	def evaluate(self,banner=True):
		while True:
			prt = []
			self.ctime = time.time()
			sizeX, sizeY = get_terminal_size()
			self.sizeX, self.sizeY = sizeX-1,sizeY-2
			screenX, screenY = self.sizeX, self.sizeY-1
			if len(self.loop)>1 and isinstance(self.loop,list):
				if "studies" in self.loop:
					studiesY = self.nr_studies
				else:
					studiesY = 0
				if "sum" in self.loop:
					sumY = self.nr_studies+self.nr_studies+1
				else:
					sumY = 0
				if "studies" in self.loop or "sum" in self.loop:
					screenY = screenY - studiesY - sumY
					ratio = divmod(screenY,(len(self.loop)-self.loop.count("studies")-self.loop.count("sum")))[0]
					rest = divmod(screenY,(len(self.loop)-self.loop.count("studies")-self.loop.count("sum")))[1]
				else:
					ratio = divmod(screenY,(len(self.loop)))[0]
					rest = divmod(screenY,(len(self.loop)))[1]
				for i,j in enumerate(self.loop):
					if j == "studies":
						self.sizeY = studiesY
						prt.append(getattr(self, "api_"+j)())
					elif j == "sum":
						self.sizeY = sumY
						prt.append(getattr(self, "api_"+j)())
					else:
						self.sizeY = ratio
						prt.append(getattr(self, "api_"+j)())
					time.sleep(0.1)


			elif len(self.loop)==1 and isinstance(self.loop,list):	
				prt.append(getattr(self, "api_"+self.loop[0])())
			elif not isinstance(self.loop,list):	
				prt.append("loop not list")
			try:
				self.ETA = self.ETA - (time.time()-self.ctime) if self.ETA - (time.time()-self.ctime) >0 else 0
				os.system("clear")
				print("\n".join(prt))
				if banner:
					banner = self.banner()
					print(banner)
				self.await_key(10)
				if self.ETA == 0:
					break

			except Exception as e:
				print(str(e))
				print("\x1b[30;41;5merror\x1b[0m")
				time.sleep(1)


	def await_key(self,ETA):
		t, o, i = select.select([sys.stdin],[],[],ETA)
		if t:
			t = sys.stdin.readline().strip().split("|")
			self.on_key(t)
			

	def on_key(self,t):
		if t[0] in ["-h","--help"]:
			print("\t<integer>")
			print("\t\tset flag value")
			print("\t+")
			print("\t\tflag +1")
			print("\tw W")
			print("\t\tflag +1")
			print("\t-")
			print("\t\tflag -1")
			print("\ts S")
			print("\t\tflag -1")
			time.sleep(10)
		elif t[0].isdigit():
			if 0<=int(t[0])<=20:
				self.flag = t[0]
			elif int(t[0])<0:
				self.flag = 0
			elif int(t[0])>20:
				self.flag = 20
		elif t[0] in ["+","w","W"]:
			if self.flag<self.nr_studies:
				self.flag = self.flag + 1 
		elif t[0] in ["-","s","S"]:
			if self.flag>0:
				self.flag = self.flag - 1
		elif t[0] in ["exit"]:
			os.system("clear")
			sys.exit()
		os.system("clear")


	def api_dot(self, time=True):
		url = self.base_url+f"/plot/{self.token}/{self.flag}/dot/{self.sizeX}/{self.sizeY}"
		headers = {
		'X-sphoin.app': 'LIadeCyi15FAwoRBkiu9fJsYPvWecSxb',
		'X-secret.sphoin.app': self.secret,
		'Content-Length': '0'}
		response = requests.request("POST", url, headers=headers)
		response = response.text[:-5]
		if time == False:
			return(response[:response.find('\x1b[0m\n\x1b[30;43;2m········time\x1b[0m')])
		return(response)

	def api_line(self, time=True):
		url = self.base_url+f"/plot/{self.token}/{self.flag}/line/{self.sizeX}/{self.sizeY}"
		headers = {
		'X-sphoin.app': 'LIadeCyi15FAwoRBkiu9fJsYPvWecSxb',
		'X-secret.sphoin.app': self.secret,
		'Content-Length': '0'}
		response = requests.request("POST", url, headers=headers)
		response = response.text[:-5]
		if time == False:
			return(response[:response.find('\x1b[0m\n\x1b[30;43;2m········time\x1b[0m')])
		return(response)

	def api_studies(self):
		url = self.base_url+f"/plot/{self.token}/studies/{self.sizeX}"
		headers = {
		'X-sphoin.app': 'LIadeCyi15FAwoRBkiu9fJsYPvWecSxb',
		'X-secret.sphoin.app': self.secret,
		'Content-Length': '0'}
		response = requests.request("POST", url, headers=headers)
		return(response.text[:-5])

	def api_sum(self):
		url = self.base_url+f"/plot/{self.token}/{self.flag}/sum/{self.sizeX}/{self.sizeY}"
		headers = {
		'X-sphoin.app': 'LIadeCyi15FAwoRBkiu9fJsYPvWecSxb',
		'X-secret.sphoin.app': self.secret,
		'Content-Length': '0'}
		response = requests.request("POST", url, headers=headers)
		return(response.text[:-8])

	def banner(self):
		disp1 = f"{self.exchange} | {self.market} | {self.interval} "
		disp2 = f"| Flag | {self.flag} "
		disp3 = f"| ETA | {dt.timedelta(seconds=int(self.ETA))} "
		disp0 = "--help"
		disp1 = f"{disp1}{disp2}{disp3}".ljust(int(self.sizeX/2*1.6)," ")
		disp0 = disp0.rjust(int(self.sizeX/2*0.4)," ")
		banner = disp1+disp0
		banner = banner.ljust(self.sizeX+1," ")
		return "\x1b[30;43;5m"+banner+"\x1b[0m"

	def api_json(self):
		url = self.base_url+f"/data/{self.token}/json"
		headers = {
		'X-sphoin.app': 'LIadeCyi15FAwoRBkiu9fJsYPvWecSxb',
		'X-secret.sphoin.app': self.secret,
		'Content-Length': '0'}
		response = requests.request("POST", url, headers=headers)
		data =  json.loads(response.text)
		if "slot_error" not in list(data):
			self.exchange = data["sphoin.slot"]["exchange"]
			self.market = data["sphoin.slot"]["market"]
			self.interval = data["sphoin.slot"]["interval"]
			self.flag = int(data["sphoin.slot"]["flag"])
			self.ETA = int(data["sphoin.slot"]["ETA"])
			try:	
				self.nr_studies = int(len(list(data["sphoin.slot"]["studies"])))
			except:
				self.nr_studies = int(len(list(data["sphoin.slot"]["studies.example"])))
		return data


	def upload(self):
		up = api_upload(self.config,self.token,self.secret)
		return(up)