"""Console script for sphoin."""
import argparse
import sys
from sphoin.app import Slot
from sphoin.utils import api_generate, api_param, api_lib, api_upload, generate_config
import os
import random
import re
from datetime import datetime as dt
import json
import os

def main():
	"""Console script for sphoin."""
	import argparse
	parser = argparse.ArgumentParser(description="Connect via apiv1 to sphoin.app slots")
	group = parser.add_mutually_exclusive_group()
	group.add_argument("-e","--example",help="view example",action="store_true")
	group.add_argument("-f","--file",help="load .json config file")
	group.add_argument("-g","--generate",help="generate .json config file", action="store_true")
	args = parser.parse_args()

	if len(sys.argv)==1:
		parser.print_help(sys.stderr)
		sys.exit(1)

	if args.file:
		slot = Slot(file=args.file)
		if slot == "slot_error":
			if input("Empty slot\nManually continue configuration? Yes/No: ") in ["y","Y","yes","Yes",""]:
				gen = generate_config()
				if gen != 0:
					Slot(file=gen)
	elif args.example:
		Slot(file="example")
	elif args.generate:
		gen = generate_config()
		if gen != 0:
			Slot(file=gen)



if __name__ == "__main__":
	sys.exit(main())  # pragma: no cover
