import shlex
import struct
import platform
import subprocess
import requests
import json
import os
import random
import re
from datetime import datetime as dt
import json
from collections import OrderedDict

base_url = "https://api.sphoin.app/apiv1"

def generate_config(**kwargs):
	while True:
		os.system("clear")
		print()
		print("sphoin.app slot .json config generator")
		print()
		print("----------------------------------------")
		print("How many sphoin studies to configure?")
		print("----------------------------------------")
		slot_lenght = input('Min length\n\t1\nMax length\n\t20\nEnter slot length:\n\t')
		if slot_lenght.isdigit() and 0<int(slot_lenght)<=20:
			example = " ".join([f"#{random.randint(1,5)}" for i in range(int(slot_lenght))])
			os.system("clear")
			print("----------------------------------------")
			print("Which studies to be added to this slot?")
			print("----------------------------------------")
			studies = input(f"Studies:\n\t#1 #2 #3 #4 #5\nExample:\n\t{example}\nEnter {slot_lenght} {'studies' if int(slot_lenght)>1 else 'study'}:\n\t")
			c = True
			for study in studies.split(" "):
				try:
					if not study[0] == "#" or not study[1].isdigit() or not 0<int(study[1])<6:
						c = False
				except:
					c = False
			if c:
				studies = studies.split(" ")
				template = api_generate(studies)
				for pos, study in enumerate(studies):
					while True:
						os.system("clear")
						print("----------------------------------------")
						print("To what technical indicators or patterns")
						print("should this study be applied?")
						print("----------------------------------------")
						lib = api_lib()
						print(" | ".join(["|".join([x,lib[x]]) for x in list(lib)]))
						print()
						print(f"Remaining studies to enter:\n\t{len(studies)-pos-1}")
						print(f"Study:\n\t{pos+1}")
						print(f"Code:\n\t{study}")
						print(f"Description:\n\tTO DO")
						print(f"Number of technical inidicators or patterns:\n\t{1 if int(study[1])<=2 else 2}")
						print(f"Example:\n\t{'11' if int(study[1])<=2 else '11 101'}")
						nr = 2 if int(study[-1])>2 else 1
						ext = "s" if int(study[-1])>2 else ""
						while True:
							raw = input(f"Enter {1 if int(study[1])<=2 else 2} technical indicator{ext} or pattern{ext} number{ext} from above:\n\t")
							if not any([0 if x.isdigit() else 1 for x in raw.split(" ")]):
								if len(raw.split(" ")) == nr:	
									for j,ind in enumerate(raw.split(" ")):
										param = api_param(ind)
										if len([i for i,x in enumerate(raw.split(" ")) if x==ind])==2 and j==1:
											ind = list(param)[0]+"_"
											template["sphoin.slot"]["studies"][f"{pos}"]["config"][ind] = param[list(param)[0]]
										else:
											template["sphoin.slot"]["studies"][f"{pos}"]["config"][list(param)[0]] = param[list(param)[0]]
										del template["sphoin.slot"]["studies"][f"{pos}"]["config"][f"indicator/pattern_{j+1}"]
										if "PASS" in list(template["sphoin.slot"]["studies"][f"{pos}"]["config"]):
											del template["sphoin.slot"]["studies"][f"{pos}"]["config"]["PASS"]
											template["sphoin.slot"]["studies"][f"{pos}"]["config"]["PASS"] = "PASS"
									break
						break
				while True:
					os.system("clear")
					print("----------------------------------------")
					print("How many studies to consider for flag?")
					print("----------------------------------------")
					flag = input(f"Min:\n\t0\nMax:\n\t{len(studies)}\nEnter slot flag:\n\t")
					if flag.isdigit() and 0<=int(flag)<=len(studies):
						template["sphoin.slot"]["flag"] = flag
						break
				if "overwrite" not in kwargs:	
					while True:
						os.system("clear")
						print("----------------------------------------")
						print("Authenticating with token and secret")
						print("generated with https://www.sphoin.app")
						print("----------------------------------------")
						token = input("Enter slot token:\n\t")
						pattern = re.compile("[A-Z0-9]{16}")
						check = True if pattern.match(token)!=None else False
						if check:
							template["token"] = token
							break
					while True:
						secret = input("Enter slot secret:\n\t")
						pattern = re.compile("[A-Z0-9]{16}")
						check = True if pattern.match(secret)!=None else False
						if check:
							template["secret"] = secret
							break
				else:
					with open(kwargs["overwrite"],"r") as f:
						data = json.load(f)
						template["token"] = data["token"]
						template["secret"] = data["secret"]
				while True:
					os.system("clear")
					print("----------------------------------------")
					print("What views to display in terminal?")
					print("----------------------------------------")
					loop = input("Views:\n\tline dot studies sum\nExample:\n\tline sum\nEnter views for loop:\n\t")
					if not any([0 if x in ["line","dot","studies","sum"] else 1 for x in loop.split(" ")]):
						template["loop"] = loop.split(" ")
						break
				now = dt.now()
				fi = f"sphoinslot-{now.hour}:{now.minute}.json"
				if "overwrite" in kwargs:
					fi = kwargs["overwrite"]
				with open(fi,"w") as f:
					json.dump(template, f,indent=5, sort_keys=False)
				if input(f"Saved as {fi}. Load it? Yes/No: ") in ["y","Y","yes","Yes",""]:
					return(fi)
				else:
					return(0)


def api_generate(studies):
	url = base_url+"/data/generate"
	payload = {
	"studies":studies
	}
	headers = {
	'X-sphoin.app': 'LIadeCyi15FAwoRBkiu9fJsYPvWecSxb',
	'Content-Type': 'application/json'}
	response = requests.request("POST", url, headers=headers, data = json.dumps(payload))
	data =  json.loads(response.text)
	return(data)

def api_param(library):
	url = base_url+"/data/parameters"
	payload = {
	"library":str(library)
	}
	headers = {
	'X-sphoin.app': 'LIadeCyi15FAwoRBkiu9fJsYPvWecSxb',
	'Content-Type': 'application/json'}
	response = requests.request("POST", url, headers=headers, data = json.dumps(payload))
	data =  json.loads(response.text)
	return(data)

def api_lib():
	url = base_url+"/data/library"
	headers = {
	'X-sphoin.app': 'LIadeCyi15FAwoRBkiu9fJsYPvWecSxb',
	'Content-Length': '0'}
	response = requests.request("GET", url, headers=headers)
	data =  json.loads(response.text)
	return(data)


def api_upload(config,TOKEN,SECRET):
	url = base_url+f"/data/{TOKEN}/upload"
	payload = config
	headers = {
	'X-sphoin.app': 'LIadeCyi15FAwoRBkiu9fJsYPvWecSxb',
	'X-secret.sphoin.app': SECRET,
	'Content-Type': 'application/json'}
	response = requests.request("POST", url, headers=headers, data = json.dumps(payload))
	data =  json.loads(response.text)
	return(data)

def get_terminal_size():
	# """ getTerminalSize()
	#  - get width and height of console
	#  - works on linux,os x,windows,cygwin(windows)
	#  originally retrieved from:
	#  http://stackoverflow.com/questions/566746/how-to-get-console-window-width-in-python
	# """
	current_os = platform.system()
	tuple_xy = None
	if current_os == 'Windows':
		tuple_xy = _get_terminal_size_windows()
		if tuple_xy is None:
			tuple_xy = _get_terminal_size_tput()
			# needed for window's python in cygwin's xterm!
	if current_os in ['Linux', 'Darwin'] or current_os.startswith('CYGWIN'):
		tuple_xy = _get_terminal_size_linux()
	if tuple_xy is None:
		tuple_xy = (80, 25)      # default value
	return tuple_xy


def _get_terminal_size_windows():
	try:
		from ctypes import windll, create_string_buffer
		# stdin handle is -10
		# stdout handle is -11
		# stderr handle is -12
		h = windll.kernel32.GetStdHandle(-12)
		csbi = create_string_buffer(22)
		res = windll.kernel32.GetConsoleScreenBufferInfo(h, csbi)
		if res:
			(bufx, bufy, curx, cury, wattr,
			 left, top, right, bottom,
			 maxx, maxy) = struct.unpack("hhhhHhhhhhh", csbi.raw)
			sizex = right - left + 1
			sizey = bottom - top + 1
			return sizex, sizey
	except:
		pass
 

def _get_terminal_size_tput():
	# get terminal width
	# src: http://stackoverflow.com/questions/263890/how-do-i-find-the-width-height-of-a-terminal-window
	try:
		cols = int(subprocess.check_call(shlex.split('tput cols')))
		rows = int(subprocess.check_call(shlex.split('tput lines')))
		return (cols, rows)
	except:
		pass

def ioctl_GWINSZ(fd):
	try:
		import fcntl
		import termios
		cr = struct.unpack('hh',
						   fcntl.ioctl(fd, termios.TIOCGWINSZ, '1234'))
		return cr
	except:
		pass
 
def _get_terminal_size_linux():
	
	cr = ioctl_GWINSZ(0) or ioctl_GWINSZ(1) or ioctl_GWINSZ(2)
	if not cr:
		try:
			fd = os.open(os.ctermid(), os.O_RDONLY)
			cr = ioctl_GWINSZ(fd)
			os.close(fd)
		except:
			pass
	if not cr:
		try:
			cr = (os.environ['LINES'], os.environ['COLUMNS'])
		except:
			return None
	return int(cr[1]), int(cr[0])
